#ifndef HASHTABLE_H
#define HASHTABLE_H

#include <vector>
using namespace std;

#include "Utility.h"
#include "FileReader.h"
#include "FileWriter.h"
#include "UniCHar2IndexMap.h"




const DWord HTEMPTY = 0xFFFFFFFF;
const DWord HTNIL = 0xFFFFFFFE;
const wchar_t __HT_DELETED_NODE = 0x0040;

typedef DWord (*HashFunc) (wstring key, unsigned int tableSize);
typedef bool (*CompareFunc) (wstring l, wstring r);

//##ModelId=4151595A050D
//##Documentation



class HashNode
{
  public:
    //##ModelId=4151595A0264
    wstring HashKey;
	int Frequency;

    union {
		DWord Next;
		DWord Index;
	};

	bool operator<(HashNode hn) const		
	{
		return Frequency<hn.Frequency;
	}
};



class HashTable
{
  public:
	// construction
	HashTable();
	~HashTable();

	HashTable(const HashTable& h)
	{
		int j = 0;
		j += j + 1;
		int y = 0;
		y = j + 3 * 4;
	}

	// allocation / deallocation
	bool Allocate (int arrSize, int tableSize = 0);
	void Deallocate ();


	bool Build(string filename, UniChar2IndexMap &charmap);

	//##ModelId=4151595A050E
    bool Load (string filename);

    //##ModelId=4151595A0510
    bool Save (string filename);

    //##ModelId=4151595A0517
    //bool Insert (wstring key, Type& node);
	/////temp code
	int Insert (wstring key,int freq);

    //##ModelId=4151595A0519
    bool Search (wstring str, vector <HashNode> & res);
	bool Search (wstring str);

    //##ModelId=4151595A051C
    bool GetNodeAtIndex(int index, HashNode& hn);

	bool SetNodeAtIndex(int index, HashNode& hn);

	bool DeleteNode(int index);

    //##ModelId=4151595A0512
    DWord Hash(wstring key);

    //##ModelId=4151595A0514
    //bool Prob(wstring key, DWord hashCode);
    int Prob(wstring key,int freq, DWord hashCode);
	 
	int getArrSize();

	DWord elementCount();

	void SetSepcialFunctions(HashFunc h, CompareFunc c);
  private:
    //##ModelId=4151595A051E
    HashNode * hTable;

    //##ModelId=4151595A051F
    int arrSize;

	int tableSize;

    //##ModelId=4151595A0520
    DWord filledElementCount;

	int lastEmptyNode;

	// function pointers to specialized functions
	HashFunc hf;
	CompareFunc cf;
};




#endif /* HASHTABLE_H_HEADER_INCLUDED_BEAEE5D4 */
