#ifndef SPELLCHECKER_H
#define SPELLCHECKER_H

#include <string>
#include <algorithm>
using namespace std;

#include "ConfigManager.h"
#include "FileReader.h"
#include "FileWriter.h"
#include "HashTable.h"
#include "UniChar2IndexMap.h"
#include "PostListResources.h"

class SpellChecker
{

	private:
		HashTable hashtable;
		ConfigManager config;
		UniChar2IndexMap charmap;
		PostListResources plResource;
		FileReader unigramPLReader,bigramPLReader;

		Byte Soundex[300];
		Byte Shapex[300];
		bool InitializeSoundex(string filename);
		bool InitializeShapex(string filename);
		int GetSoundex(wstring word);
		int GetShapex(wstring word);
			

	public:	
		bool Initialize();
		bool SpellCheck(wstring str, vector<wstring> &suggestedList);
		~SpellChecker();
};
		

#endif