#include "Utility.h"






// trims a given string at start and end
string Trim (string& str)
{
	int i = 0;
	while (IsWhitespace (str[i]))
		i++;

	int j = str.length()-1;
	while (IsWhitespace(str[j]))
		j--;

	int n = j-i+1;
	str = str.substr(i, n);
	return str;
}

wstring Trim(wstring& wstr)
{
	int i = 0;
	while (IsWhitespace (wstr[i]))
		i++;

	int j = wstr.length()-1;
	while (IsWhitespace (wstr[j]))
		j--;

	int n = j-i+1;
	return (wstr = wstr.substr(i, n));
}

// converts ascii-based string (string) to unicode-based string (wstring)
wstring String2Wstring (string sString)
{
	wstring wsString;

	int n = sString.length();
	for (int i = 0; i < n; i++)
		wsString += (wchar_t)sString[i];

	return wsString;
}

// converts unicode-based string (wstring) to ascii-based string (string) 
string WString2String (wstring wsString)
{
	string sString;

	int n = wsString.length();
	for (int i = 0; i < n; i++)
		sString += (char)wsString[i];

	return sString;
}

int wstring2int (wstring wstr)
{
	string str = WString2String(wstr);
	return atoi(str.data());
}





bool IsWhitespace (wchar_t ch)
{
	return (ch == 0x0020 || ch == 0x000A || ch == 0x000D  || ch == 0x0009);
}

wstring RemoveWhitespaces (wstring str)
{
	wstring resStr;	
	for (int i = 0; i < str.length(); i++){
		if (!(str[i] == __SPACE || str[i] == __ZWNJ || str[i] == __ZWJ
				|| str[i] == 0x000D || str[i] == 0x000A || str[i] == 0x0009))
			resStr += str[i];
	}
	return resStr;
}


// removes diacritics from urdu word string
wstring RemoveDiacritics(wstring word)
{
	wchar_t wch;
	wstring lexeme;

	//bool diacMarked = true;	// start of word
	for (int i = 0; i < word.size(); i++)
	{
		wch = word[i];

		if (wch == __zebr || wch == __zer || wch == __pesh || wch == __jezm ||
			wch == __shd || wch == __med)
				; // skip
		else  // if some letter
			lexeme += wch;
	}

	return lexeme;
}


int EditDistance(wstring s,wstring t)
{
	int n=s.length(),m=t.length();
	int i,j;
	if(n==0)
		return m;
	if(m==0)
		return n;

	int **d;
	d=new int *[m+1];
	for(i=0;i<=m;i++)
		d[i]=new int[n+1];

	for(i=0;i<=m;i++)
		d[i][0]=i;

	for(i=0;i<=n;i++)
		d[0][i]=i;

	int cost;
	for(i=1;i<=m;i++)
	{
		for(j=1;j<=n;j++)
		{
			if(t[i-1]==s[j-1])
				cost=0;
			else
				cost=1;

			if((d[i-1][j]) < (d[i][j-1]))
			{
				if((d[i-1][j]+1) < (d[i-1][j-1]+cost))
					d[i][j]=d[i-1][j]+1;
				else
					d[i][j]=d[i-1][j-1]+cost;
			}
			else
			{
				if((d[i][j-1]+1) < (d[i-1][j-1]+cost))
					d[i][j]=d[i][j-1]+1;
				else
					d[i][j]=d[i-1][j-1]+cost;
			}

		}
	}

	int distance = d[m][n];

	for(i=0;i<=m;i++)
		delete []d[i];
	delete []d;

	return distance;

}